"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MicroOrmJsonApiModule = void 0;
const nestjs_1 = require("@mikro-orm/nestjs");
const json_api_nestjs_1 = require("@klerick/json-api-nestjs");
const factory_1 = require("./factory");
const service_1 = require("./service");
class MicroOrmJsonApiModule {
    static forRoot(options) {
        const optionProvider = {
            provide: json_api_nestjs_1.MODULE_OPTIONS_TOKEN,
            useValue: options,
        };
        const microOrmModule = nestjs_1.MikroOrmModule.forFeature(options.entities, options.connectionName);
        const currentProvider = [
            ...(options.providers || []),
            optionProvider,
            (0, factory_1.CurrentMicroOrmProvider)(options.connectionName),
            (0, factory_1.CurrentEntityManager)(),
            (0, factory_1.CurrentEntityMetadata)(),
            (0, factory_1.RunInTransactionFactory)(),
            (0, factory_1.EntityPropsMap)(options.entities),
            {
                provide: json_api_nestjs_1.ErrorFormatService,
                useClass: service_1.MikroOrmFormatErrorService,
            },
        ];
        const currentImport = [
            microOrmModule,
            ...(options.imports || []),
        ];
        return {
            module: MicroOrmJsonApiModule,
            imports: currentImport,
            providers: currentProvider,
            exports: [...currentProvider, ...currentImport],
        };
    }
    static getUtilProviders(entity) {
        return [
            (0, factory_1.CurrentEntityRepository)(entity),
            (0, factory_1.CheckRelationNameFactory)(),
            (0, factory_1.OrmServiceFactory)(),
            service_1.MicroOrmUtilService,
            (0, factory_1.FindOneRowEntityFactory)(),
        ];
    }
}
exports.MicroOrmJsonApiModule = MicroOrmJsonApiModule;
//# sourceMappingURL=micro-orm-json-api.module.js.map