"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSortObject = getSortObject;
exports.getQueryForCount = getQueryForCount;
const json_api_nestjs_shared_1 = require("@klerick/json-api-nestjs-shared");
function getSortObject(query) {
    const { sort } = query;
    const sortObject = {};
    if (!sort)
        return sortObject;
    const { target = {}, ...relation } = sort;
    for (const [filed, sortType] of json_api_nestjs_shared_1.ObjectTyped.entries(target)) {
        Reflect.set(sortObject, filed, sortType);
    }
    for (const [relationName, orderConfig = {}] of json_api_nestjs_shared_1.ObjectTyped.entries(relation)) {
        const name = relationName;
        sortObject[name] = {};
        for (const [field, sortType] of json_api_nestjs_shared_1.ObjectTyped.entries(orderConfig)) {
            sortObject[name][field] = sortType;
        }
    }
    return sortObject;
}
function getQueryForCount(query) {
    const querySelect = this.microOrmUtilService.queryBuilder();
    const sortObject = getSortObject(query);
    querySelect.orderBy(Object.keys(sortObject).length > 0
        ? sortObject
        : {
            [this.microOrmUtilService.currentPrimaryColumn]: 'ASC',
        });
    const expressionArrayForTarget = this.microOrmUtilService.getFilterExpressionForTarget(query);
    const expressionArrayForRelation = this.microOrmUtilService.getFilterExpressionForRelation(query);
    const resultExpression = [
        ...expressionArrayForTarget,
        ...expressionArrayForRelation,
    ];
    for (const expression of resultExpression) {
        querySelect.andWhere(expression);
    }
    return querySelect;
}
//# sourceMappingURL=get-query-for-count.js.map