"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getOne = getOne;
const common_1 = require("@nestjs/common");
const core_1 = require("@mikro-orm/core");
async function getOne(id, query) {
    const queryBuilder = this.microOrmUtilService.queryBuilder().where({
        [this.microOrmUtilService.currentPrimaryColumn]: id,
    });
    const resultQueryBuilder = this.microOrmUtilService.prePareQueryBuilder(queryBuilder, query);
    await resultQueryBuilder.applyFilters();
    const resultItem = await resultQueryBuilder.getSingleResult();
    if (!resultItem) {
        const error = {
            code: 'invalid_arguments',
            message: `Resource '${this.microOrmUtilService.currentAlias}' with id '${id}' does not exist`,
            path: ['fields'],
        };
        throw new common_1.NotFoundException([error]);
    }
    return (0, core_1.wrap)(resultItem).toJSON();
}
//# sourceMappingURL=get-one.js.map